
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
public _instsysisr
public _restsysisr
public _vmode
public _setpal
public _getkey
public _keywait
public _pixel
public _xpixel
public _tempmem
public _update
public _clear
;-------------------------------------------------------------------------------
.model large
.code
;-------------------------------------------------------------------------------
memoff  dw  ?
memseg  dw  ?
keyoff  dw  ?
keyseg  dw  ?
oldvec  dd  ?
;-------------------------------------------------------------------------------
sysisr:
    cmp ah,4Fh
    jz intercept
    jmp cs:[oldvec]
intercept:
    push bx
    push cx
    push dx
    push ds
    mov bx,cs:[keyoff]
    mov ds,cs:[keyseg]
    mov dl,al
    mov cl,07h
    shr dl,cl
    and dl,01h
    xor dl,01h
    and al,7Fh
            ;ESC
    cmp al,01h
    jnz xxx000
    mov [bx+0],dl
    jmp sysisrret
xxx000:     ;UP
    cmp al,48h
    jnz xxx001
    mov [bx+1],dl
    jmp sysisrret
xxx001:     ;DOWN
    cmp al,50h
    jnz xxx002
    mov [bx+2],dl
    jmp sysisrret
xxx002:     ;RIGHT
    cmp al,4Dh
    jnz xxx003
    mov [bx+3],dl
    jmp sysisrret
xxx003:     ;LEFT
    cmp al,4Bh
    jnz xxx004
    mov [bx+4],dl
    jmp sysisrret
xxx004:
    cmp al,39h
    jnz xxx005
    mov [bx+5],dl
    jmp sysisrret
xxx005:
sysisrret:
    pop ds
    pop dx
    pop cx
    pop bx
    clc
    retf 2
;-------------------------------------------------------------------------------
_instsysisr:
    push bp
    mov bp,sp
    push ds
    push es
    mov ax,[bp+6]
    mov dx,[bp+8]
    mov cs:[keyoff],ax
    mov cs:[keyseg],dx
    mov ax,3515h
    int 21h
    mov word ptr cs:[oldvec],bx
    mov word ptr cs:[oldvec+2],es
    mov ax,2515h
    mov dx,offset sysisr
    push cs
    pop ds
    int 21h
    pop es
    pop ds
    pop bp
    retf
;-------------------------------------------------------------------------------
_restsysisr:
    push ds
    mov ax,2515h
    mov dx,word ptr cs:[oldvec]
    mov ds,word ptr cs:[oldvec+2]
    int 21h
    pop ds
    retf
;-------------------------------------------------------------------------------
_vmode:
    push bp
    mov bp,sp
    mov ah,00h
    mov al,[bp+6]
    int 10h
    pop bp
    retf
;-------------------------------------------------------------------------------
_setpal:
    push bp
    mov bp,sp
    push es
    mov ax,1012h
    mov bx,0000h
    mov cx,0100h
    mov dx,[bp+6]
    mov es,[bp+8]
    int 10h
    pop es
    pop bp
    retf
;-------------------------------------------------------------------------------
_getkey:
    mov ah,01h
    int 16h
    jnz _keywait
    xor ax,ax
    retf
;-------------------------------------------------------------------------------
_keywait:
    mov ah,00h
    int 16h
    retf
;-------------------------------------------------------------------------------
_pixel:
    push bp
    mov bp,sp
    push ds
    cmp word ptr [bp+6],319
    jg pixret
    cmp word ptr [bp+8],199
    jg pixret
    mov ax,[bp+8]
    mov bx,0140h
    mul bx
    mov bx,ax
    add bx,[bp+6]
    add bx,cs:[memoff]
    mov ax,cs:[memseg]
    mov ds,ax
    mov al,[bp+10]
    mov [bx],al
pixret:
    pop ds
    pop bp
    retf
;-------------------------------------------------------------------------------
_xpixel:
    push bp
    mov bp,sp
    push ds
    cmp byte ptr [bp+10],0FFh
    jz xpixret
    cmp word ptr [bp+6],319
    jg xpixret
    cmp word ptr [bp+8],199
    jg xpixret
    mov ax,[bp+8]
    mov bx,0140h
    mul bx
    mov bx,ax
    add bx,[bp+6]
    add bx,cs:[memoff]
    mov ax,cs:[memseg]
    mov ds,ax
    mov al,[bp+10]
    mov [bx],al
xpixret:
    pop ds
    pop bp
    retf
;-------------------------------------------------------------------------------
_tempmem:
    push bp
    mov bp,sp
    mov ax,[bp+6]
    mov dx,[bp+8]
    mov cs:[memoff],ax
    mov cs:[memseg],dx
    pop bp
    retf
;-------------------------------------------------------------------------------
_update:
    push di
    push si
    push ds
    push es
    mov si,cs:[memoff]
    mov ds,cs:[memseg]
    mov di,0A000h
    mov es,di
    xor di,di
    mov cx,7D00h
    rep movsw
    pop es
    pop ds
    pop si
    pop di
    retf
;-------------------------------------------------------------------------------
_clear:
    push bp
    mov bp,sp
    push ds
    mov al,[bp+6]
    mov ah,al
    mov cx,7D00h
    mov bx,cs:[memseg]
    mov ds,bx
    mov bx,cs:[memoff]
clearloop:
    mov [bx],ax
    add bx,0002h
    loop clearloop
    pop ds
    pop bp
    retf
;-------------------------------------------------------------------------------
end
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------

