
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <math.h>

#define DOTSPACE 50
#define FIRELEN 8
#define YELLOW 0x02
#define BLUE 0x04

void instsysisr ( void * );
void restsysisr ( void );
void vmode ( unsigned char );
void setpal ( unsigned char * );
void pixel ( unsigned short, unsigned short, unsigned char );
void xpixel ( unsigned short, unsigned short, unsigned char );
void tempmem ( void * );
void update ( void );
void clear ( unsigned char );
unsigned short keywait ( void );
unsigned short getkey ( void );
FILE *fp;

unsigned short ra;
unsigned short rb;
unsigned short rc;
unsigned short rg;
unsigned short rh;

float fa;
float fb;

float firex;
float firey;
float fired;
unsigned short firea;
unsigned short firen;

float xx;
float yy;
float dx;
unsigned short ang;

float oxx;
float oyy;
float odx;
unsigned short ohits;
unsigned short oang;

/**/ unsigned short ocount;

const float trigx[16]={+0.00000000,+0.38268343,+0.70710678,+0.92387953,+1.00000000,+0.92387953,+0.70710678,+0.38268343,+0.00000000,-0.38268343,-0.70710678,-0.92387953,-1.00000000,-0.92387953,-0.70710678,-0.38268343};
const float trigy[16]={-1.00000000,-0.92387953,-0.70710678,-0.38268343,+0.00000000,+0.38268343,+0.70710678,+0.92387953,+1.00000000,+0.92387953,+0.70710678,+0.38268343,+0.00000000,-0.38268343,-0.70710678,-0.92387953};

void putship ( short, short , unsigned char);
void moveship ( float *, float *, float *, unsigned short * );
unsigned short direction(float,float,float,float);
float distance ( float, float, float, float );

char gstring[16];
unsigned char key[16];
unsigned char numbers[10][5][3];
unsigned char palette[768];
unsigned char arrow[16][20][20];
unsigned char ship[16][47][47];
unsigned char miss[16][20][20];
unsigned char *vidmem;
//------------------------------------------------------------------------------
void main ( void )
{
    if((vidmem=malloc(64000))==NULL)
    {
        printf("Memory Allocation Error\n");
        exit(1);
    }
    tempmem(vidmem);
    if((fp=fopen("NUM.DAT","rb"))==NULL)
    {
        printf("Error opening file <NUM.DAT>\n");
        exit(1);
    }
    fread(numbers,1,150,fp);
    fclose(fp);
    if((fp=fopen("PAL.DAT","rb"))==NULL)
    {
        printf("Error opening file <PAL.DAT>\n");
        exit(1);
    }
    fread(palette,3,256,fp);
    fclose(fp);
    if((fp=fopen("MISS.DAT","rb"))==NULL)
    {
        printf("Error opening file <MISS.DAT>\n");
        exit(1);
    }
    fread(miss,1,6400,fp);
    fclose(fp);
    if((fp=fopen("ARROW.DAT","rb"))==NULL)
    {
        printf("Error opening file <ARROW.DAT>\n");
        exit(1);
    }
    fread(arrow,1,6400,fp);
    fclose(fp);
    if((fp=fopen("SHIP.DAT","rb"))==NULL)
    {
        printf("Error opening file <SHIP.DAT>\n");
        exit(1);
    }
    fread(ship,1,35344,fp);
    fclose(fp);

    xx=10000;
    yy=10000;
    dx=0;
    ang=0;

    oxx=10000;
    oyy=9950;
    odx=4;
    oang=0;
    ohits=0;
/**/ ocount=0;

    firen=FIRELEN;

    for(ra=0;ra<16;ra++) key[ra]=0;

    vmode(0x13);
    setpal(palette);
    instsysisr(key);
    while(1)
    {
        rg=(unsigned short)xx-(((unsigned short)xx/DOTSPACE)*DOTSPACE);
        rg=DOTSPACE-1-rg;
        rh=(unsigned short)yy-(((unsigned short)yy/DOTSPACE)*DOTSPACE);
        rh=DOTSPACE-1-rh;

        // clear screen with background color ----------------------------------
        clear(BLUE);
        // place reference dots ------------------------------------------------
        for(rb=rh;rb<200;rb+=DOTSPACE) for(ra=rg;ra<320;ra+=DOTSPACE) pixel(ra,rb,YELLOW);
        // put other ship ------------------------------------------------------
        fa=159+oxx-xx;
        fb=99+oyy-yy;
        if((fa>-24)&&(fa<344)&&(fb>-24)&&(fb<224)) putship(fa,fb,oang);
        // put center ship -----------------------------------------------------
        putship(159,99,ang);
        // place projectile ----------------------------------------------------
        if(firen<FIRELEN)
        {
            firen++;
            firex+=fired*trigx[firea];
            firey+=fired*trigy[firea];
            rg=149+firex-xx;
            rh=89+firey-yy;
            for(rb=0;rb<20;rb++)
                for(ra=0;ra<20;ra++)
                    xpixel(rg+ra,rh+rb,miss[firea][rb][ra]);
/**/        if(distance(firex,firey,oxx,oyy)<20)
            {
                firen=FIRELEN;
                if(ohits++==5)
                {
                    ohits=0;
                    oxx=((float)rand()*15000/32767)+2500;
                    oyy=((float)rand()*15000/32767)+2500;
                }
            }
        }
        // place thrust bar ----------------------------------------------------
        rg=(dx*5)+5;
        for(rb=5;rb<10;rb++) for(ra=5;ra<rg;ra++) pixel(ra,rb,YELLOW);
        // put position info ---------------------------------------------------
        rg=xx; rh=yy;
        sprintf(gstring,"%05u",rg);
        for(rc=0;rc<5;rc++)
        {
            for(rb=0;rb<5;rb++)
            for(ra=0;ra<3;ra++)
            xpixel(5+ra+(rc<<2),11+rb,numbers[gstring[rc]-0x30][rb][ra]);
        }
        sprintf(gstring,"%05u",rh);
        for(rc=0;rc<5;rc++)
        {
            for(rb=0;rb<5;rb++)
            for(ra=0;ra<3;ra++)
            xpixel(36+ra+(rc<<2),11+rb,numbers[gstring[rc]-0x30][rb][ra]);
        }
        // put direction-to-target arrow ---------------------------------------
        rc=direction(xx,oyy,oxx,yy);
        for(rb=0;rb<20;rb++)
        for(ra=0;ra<20;ra++) xpixel(295+ra,11+rb,arrow[rc][rb][ra]);
        // put distance to target ----------------------------------------------
        rg=distance(xx,yy,oxx,oyy);
        sprintf(gstring,"%05u",rg);
        for(rc=0;rc<5;rc++)
        {
            for(rb=0;rb<5;rb++)
            for(ra=0;ra<3;ra++)
            xpixel(295+ra+(rc<<2),5+rb,numbers[gstring[rc]-0x30][rb][ra]);
        }
//xxxxxxxxxxxxxxxxxxxxxxxx
        update();
        if(key[0]) break;
        if(key[1]) key[12]=1;
        if(key[2]) key[13]=1;
        if(key[3]) key[14]=1;
        if(key[4]) key[15]=1;
        if((key[10]=(key[10]+1))==8)
        {
            key[10]=0;
            if(key[14]) { key[14]=0; ang=(ang+1)&15; }
            if(key[15]) { key[15]=0; ang=(ang-1)&15; }
            if(key[12]) { key[12]=0; if(dx<=9.0) dx+=1.0; }
            if(key[13]) { key[13]=0; if(dx>=1.0) dx-=1.0; }
        }
        if((key[5])&&(firen>=FIRELEN))
        {
            firea=ang;
            firex=xx+10*trigx[firea];
            firey=yy+10*trigy[firea];
            fired=dx+10;
            firen=0;
        }
        moveship(&xx,&yy,&dx,&ang);

/**/    if(ocount++==10)
        {
            ocount=0;
            ra=rand()>>13;
            if(ra==0) oang=(oang+1)&15;
            if(ra==2) oang=(oang-1)&15;
        }
        moveship(&oxx,&oyy,&odx,&oang);
    }
    restsysisr();
    vmode(0x03);
}
//------------------------------------------------------------------------------
void putship ( short x, short y, unsigned char o )
{
    short i;
    short j;
    short k;
    short l;

    for(j=0;j<47;j++)
        for(i=0;i<47;i++)
        {
            k=x+i-24;
            l=y+j-24;
            if((k>=0)&&(l>=0)) xpixel(k,l,ship[o][j][i]);
        }
}
//------------------------------------------------------------------------------
void moveship ( float *x, float *y, float *d, unsigned short *a )
{
    *x+=*d * trigx[*a];
    *y+=*d * trigy[*a];
    if(*x<=0.0)
    {
        *x=0.0-*x;
        switch(*a)
        {
            case  9: *a= 7; break;
            case 10: *a= 6; break;
            case 11: *a= 5; break;
            case 12: *a= 4; break;
            case 13: *a= 3; break;
            case 14: *a= 2; break;
            case 15: *a= 1; break;
        }
    }
    if(*x>=20000.0)
    {
        *x=40000.0-*x;
        switch(*a)
        {
            case  1: *a=15; break;
            case  2: *a=14; break;
            case  3: *a=13; break;
            case  4: *a=12; break;
            case  5: *a=11; break;
            case  6: *a=10; break;
            case  7: *a= 9; break;
        }
    }
    if(*y<=0.0)
    {
        *y=0.0-*y;
        switch(*a)
        {
            case 13: *a=11; break;
            case 14: *a=10; break;
            case 15: *a= 9; break;
            case  0: *a= 8; break;
            case  1: *a= 7; break;
            case  2: *a= 6; break;
            case  3: *a= 5; break;
        }
    }
    if(*y>=20000.0)
    {
        *y=40000.0-*y;
        switch(*a)
        {
            case  5: *a= 3; break;
            case  6: *a= 2; break;
            case  7: *a= 1; break;
            case  8: *a= 0; break;
            case  9: *a=15; break;
            case 10: *a=14; break;
            case 11: *a=13; break;
        }
    }
}
//------------------------------------------------------------------------------
unsigned short direction( float x1, float y1, float x2, float y2 )
{
    float x;
    float y;
    float z;

    x=x2-x1;
    y=y2-y1;

    if(x==0) if(y>=0) return(0); else return(8);
    z=y/x;
    if((x>0)&&(y>=0))
    {
        if(z>+5.0273949) return(0);
        if(z>+1.4960576) return(1);
        if(z>+0.6681786) return(2);
        if(z>+0.1989124) return(3);
        return(4);
    }
    if((x>0)&&(y<0))
    {
        if(z<-5.0273949) return(8);
        if(z<-1.4960576) return(7);
        if(z<-0.6681786) return(6);
        if(z<-0.1989124) return(5);
        return(4);
    }
    if((x<0)&&(y>=0))
    {
        if(z<-5.0273949) return(0);
        if(z<-1.4960576) return(15);
        if(z<-0.6681786) return(14);
        if(z<-0.1989124) return(13);
        return(12);
    }
    if((x<0)&&(y<0))
    {
        if(z>+5.0273949) return(8);
        if(z>+1.4960576) return(9);
        if(z>+0.6681786) return(10);
        if(z>+0.1989124) return(11);
        return(12);
    }
    return(0);
}
//------------------------------------------------------------------------------
float distance ( float x1, float y1, float x2, float y2 )
{
    return(sqrt(((x2-x1)*(x2-x1))+((y2-y1)*(y2-y1))));
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

